class Instructions{
  float x;
  float finalx; // where the instructions should end up; x values are right-aligned
  float offscreenx; // where the instructions will stop off-screen
  float y; // top alignment
  float w; // text box widths
  float space; // spacing between paragraphs
  float leading; // leading between lines
  float sWeight; // stroke weight for connection legend
  
  float caty;
  CatLegend catVlog;
  CatLegend catCooking;
  CatLegend catGamer;
  CatLegend catMusic;
  CatLegend catDance;
  CatLegend catEnt;
  CatLegend catOther;
  CatLegend catAll;
  
  Tooltip lineTier1;
  Tooltip lineTier2;
  Tooltip lineTierAll;
  Tooltip rewindTip;
  float line1y;
  float line2y;
  float lineally;
  
  boolean tierAllOn = true;
  boolean tier1On = false;
  boolean tier2On = false;
  boolean rewindOn = false;

  Instructions(){
    finalx = width-40;
    offscreenx = width+450;
    x = width-40;
    y = 20;
    w = -400; // negative for right alignment
    space = 20;
    leading = 14;
    sWeight = 2;
    lineally = y+20+(12*3)+space+30+12+12+space+25;
    line1y = y+20+(12*3)+space+30+12+12+space+25+10;
    line2y = y+20+(12*3)+space+30+12+12+space+25+20;
    
    caty = y+20+(12*3)+space+30;
    
    // declared in display so that they move off-screen with rest of instructions
    catVlog = new CatLegend(0, vlogC, x-5, caty);
    catCooking = new CatLegend(1, cookingC, x-5, caty);
    catGamer = new CatLegend(2, gamerC, x-5, caty);
    catMusic = new CatLegend(3, musicC, x-5, caty);
    catDance = new CatLegend(4, danceC, x-5, caty);
    catEnt = new CatLegend(5, entC, x-5, caty);
    catOther = new CatLegend(6, otherC, x-5, caty);
    catAll = new CatLegend(7, #ffffff, x-5, caty);
    
    lineTierAll = new Tooltip(x-95, lineally-10, "All Connections", "center");
    lineTier1 = new Tooltip(x-95, line1y-10, "Direct Connections", "center");
    lineTier2 = new Tooltip(x-95, line2y-10, "Related Material", "center");
    rewindTip = new Tooltip(x-70, y+230, "Watch Youtube Rewind 2013", "center");
  
  }
  
  void display(){
    
    textAlign(RIGHT, TOP);
    rectMode(CORNER);
    textFont(av18Font);
    fill (titleC);
    text("Instructions", x, y);
    text("Categories", x, y+20+(12*3)+space);
    text("Connections", x, y+20+(12*3)+space+30+12+12+space);
    textFont(av12Font);
    textLeading(leading);
    fill(darkGray);
    text("Click on any of the youtubers to learn more about them. Hover for names and values. Youtubers are ordered according to appearance in Youtube Rewind, starting with Kid President and ending with Pewdiepie.", x, y+20, w, 100);
    text("Click to isolate a category.", x, y+20+(12*3)+space+30+12);
    text("Click to isolate a connection level.", x, y+20+(12*3)+space+30+12+12+space+25+20+8);
    textFont(av8Font);
    text("Source: All data was taken from Youtube on February 24, 2014.", x, height-40, w, 100);

    // category circles
    catVlog.display();
    catCooking.display();
    catGamer.display();
    catMusic.display();
    catDance.display();
    catEnt.display();
    catOther.display();
    catAll.display();
    
    // connection lines legend
    strokeWeight(sWeight);
    strokeCap(SQUARE);
    stroke(titleC);
    line(x-5, lineally, x-25, lineally);
    stroke(lightGray);
    line(x-25, lineally, x-45, lineally);
    stroke(titleC);
    line(x-45, lineally, x-65, lineally);
    stroke(lightGray);
    line(x-65, lineally, x-85, lineally);
    stroke(titleC);
    line(x-85, lineally, x-105, lineally);
    stroke(titleC);
    line(x-5, line1y, x-105, line1y);
    stroke(lightGray);
    line(x-5, line2y, x-105, line2y);
    
    lineTierAll.display();
    lineTier1.display();
    lineTier2.display();
    
    // check for line legends hover
    if (mouseX > x-105 && mouseX < x-5){
      if (mouseY > lineally-2 && mouseY < lineally+sWeight+2){
        tierAllOn = true;
        tier1On = false;
        tier2On = false;
        lineTierAll.onHover();
        lineTier1.offHover();
        lineTier2.offHover();
      }else if (mouseY > line1y-2 && mouseY < line1y+sWeight+2) {
        // if hovering on first line
        tierAllOn = false;
        tier1On = true;
        tier2On = false;
        lineTierAll.offHover();
        lineTier1.onHover();
        lineTier2.offHover();
      } else if (mouseY > line2y-2 && mouseY < line2y+sWeight+2) {
        // if hovering on second line
        tierAllOn = false;
        tier2On = true;
        tier1On = false;
        lineTierAll.offHover();
        lineTier2.onHover();
        lineTier1.offHover();
      } else {
        tierAllOn = false;
        tier1On = false;
        tier2On = false;
        lineTierAll.offHover();
        lineTier2.offHover();
        lineTier1.offHover();
      }
    } else {
      tierAllOn = false;
      tier1On = false;
      tier2On = false;
      lineTierAll.offHover();
      lineTier2.offHover();
      lineTier1.offHover();
    }
    
    //check to see if channels are clicked
    if (anyClicked == true) {
      offScreen();
    } else {
      onScreen();
    }
    
    // rewind button
    float triStartX = x-140+25;
    float triStartY = y+280;

    fill(titleC);
    rectMode(CORNER);
    rect(x, y+240, -140, 80, 10);
    fill(#ffffff);
    triangle(triStartX, triStartY, triStartX+40, triStartY-20, triStartX+40, triStartY+20);
    triangle(triStartX+45, triStartY, triStartX+40+45, triStartY-20, triStartX+40+45, triStartY+20);
  
    rewindTip.display();
  
    // check for rewind button hover
    if (mouseX < x && mouseX > x-140 && mouseY > y+240 && mouseY < y+320){
      rewindOn = true;
      rewindTip.onHover();
    } else {
      rewindTip.offHover();
      rewindOn = false;
    }
  
  }


  void offScreen(){
    float distX = x - offscreenx;
    if (x < offscreenx) {
      x = x - distX/8;
    }
    catVlog.alpha = 0;
    catCooking.alpha = 0;
    catGamer.alpha = 0;
    catMusic.alpha = 0;
    catDance.alpha = 0;
    catEnt.alpha = 0;
    catOther.alpha = 0;
    catAll.alpha = 0;
    
  }

  void onScreen(){
    float distX = x - finalx;
    if (x > finalx) {
      x = x - distX/4;
    }
    catVlog.alpha = 255;
    catCooking.alpha = 255;
    catGamer.alpha = 255;
    catMusic.alpha = 255;
    catDance.alpha = 255;
    catEnt.alpha = 255;
    catOther.alpha = 255;
    catAll.alpha = 255;
    
  }

}
