// CLASS FOR YOUTUBER CIRCLES
class Youtuber{
  float xpos; // x coordinate
  float ypos; // y coordinate
  float r2=15; // radius
  String title; // Youtuber's title
  float titleWidth; // width of title
  String name; // Youtube's second title and/or name
  
  float cSubs; // channel sub count
  
  color c; // circle color
  color c2; // color copy for title text
  float alpha; // alpha value for channel circle
  String hexColor; // hex color string
  int intColor; // hex color converted to int
  int r;
  int g;
  int b;
  int speed; // speed of animation
  
  boolean ifClicked; // check if this channel is clicked
  boolean ifHovered; // check if this channel has hover on
  boolean clickable; // can toggle if anything can be clicked or not
  boolean reverse = false; // if the alpha needs to be lowered or not
  PImage image; // Youtuber image
  float imageSize = 0; // Initial image width&height before scaling
  float imageSize2 = 280; // Final image size
  
  float xpos2; // x coordinate for connections
  float ypos2; // y coordinate for connections
  float xposi; // x coordinate for the image center;
  float yposi; // y coordinate for the image center;
  
  float distX;
  float distY; 
  
  float mostWatchedX = -transX-500;
  float mostWatchedX2 = 40-transX; // final position
  float mostWatchedY = height-transY-200;
  String mostWatchedName;
  String mostWatchedViews;
  String URL;
  
  float titleY = height-transY+100;
  float titleY2 = 720-transY;
  
  String[] connects; // string list of connections

  Tooltip cTooltip; // channel tooltip
  ReturnBtn returnBtn;
  
  Youtuber(float tempxpos, float tempypos, String temptitle, String tempc, String tempname, String tempimg, int tempsubs, String[] tempconnects, String tempmostwatched, String tempmostwatchedviews, String tempurl){
    xpos = tempxpos;
    ypos = tempypos;
    xpos2 = xpos;
    xpos2 = ypos;
    title = temptitle; 
    name = tempname;
    ifClicked = false;
    ifHovered = false;
    clickable = true;
    image = loadImage(tempimg);
    connects = tempconnects;
    mostWatchedName = tempmostwatched;
    mostWatchedViews = tempmostwatchedviews;
    URL = tempurl;
    
    alpha = 255;
    
    cTooltip = new Tooltip(xpos, ypos-r2-5, title, "center");
    
    cSubs = tempsubs;
    
    xposi = 0;
    yposi = 0;
    speed = 15;
    distX = 0;
    distY = 0;
    
    if (tempc.equals("vlog")){
      c = vlogC;
    } else if (tempc.equals("cooking")){
      c = cookingC;
    } else if (tempc.equals("gamer")){
      c = gamerC;
    } else if (tempc.equals("music")){
      c = musicC;
    } else if (tempc.equals("dance")){
      c = danceC;
    } else if (tempc.equals("ent")){
      c = entC;
    } else if (tempc.equals("other")){
      c = otherC;
    } else {
      c = #000000;
    }
    
    returnBtn = new ReturnBtn(c);
    
    hexColor = hex(c);
    intColor = unhex(hexColor);
    
    r = ((intColor >> 16) & 0xFF);
    g = ((intColor >> 16) & 0xFF);
    b = ((intColor >> 8) & 0xFF);
    
  }
  

  void display(){
    smooth();
    if (reverse == true) {
      noStroke();
      fill(lightGray2, alpha);
    } else {
      noStroke();
      fill(c, alpha);
    }
    ellipse(xpos, ypos, r2, r2);
    
    hexColor = hex(c);
    intColor = unhex(hexColor);
    c2 = (color(r,g,b));

    // CHECK FOR HOVER
    distX = sq(xpos+transX - mouseX);
    distY = sq(ypos+transY - mouseY);
    if ((distX + distY) <= sq(r2/2)){
      onHover();
      ifHovered = true;
    } else {
      offHover();
    }
    
    active();
    titleText();
    mostWatched();
        
   }
   
  void showTip(){
    cTooltip.display();
  }
  
  void onHover(){
    textAlign(RIGHT);
    if (anyClicked == false){
      titleC = (c2);
    }
    // Change text color to current category on hover
      if (r > ((intColor >> 16) & 0xFF)) {
        r = r - speed;
      }
      if (r < ((intColor >> 16) & 0xFF)) {
        r = r + speed;
      }
      if (g > ((intColor >> 8) & 0xFF)) {
        g = g - speed;
      }
      if (g < ((intColor >> 8) & 0xFF)) {
        g = g + speed;
      }
      if (b > (intColor & 0xFF)) {
         b = b - speed;
      }
      if (b < (intColor & 0xFF)) {
         b = b + speed;
      }
      c2 = (color(r,g,b));
      cTooltip.onHover(); //tooltip hover
      
  }
    
  void offHover(){
    ifHovered = false;
    cTooltip.offHover();
  }
  
  void onClick(){
    if (anyClicked == true){
      anyClicked = false; // If something was already clicked, reset to defaults
    } else {
      ifClicked = true;
      clickable = false; // makes it so nothing can be clicked  
    }
  }

  void active(){
    imageMode(CENTER);
    image(image, xposi, yposi, imageSize, imageSize);

    if (ifClicked == true) { // if channel is selected
      // control connect lines
      xpos2 = xposi; 
      ypos2 = yposi;
      // animate image in
      float imageDist = imageSize2 - imageSize;
      if (imageSize < imageSize2) {
        imageSize = imageSize + imageDist/8;
      }
      if (imageSize > imageSize2-3) {
        imageSize = imageSize2;
        // show return button
        returnBtn.display();
      }
      // dim alpha channel
      alpha = 100;
      
    }
    if (ifClicked == false){ // if channel isn't selected
      // fix connect lines
      xpos2 = xpos;
      ypos2 = ypos;
      //animate image out
      float imageDist = 0 - imageSize;
      if (imageSize > 0) {
        imageSize = imageSize + imageDist/4;
      }
      if (imageSize < 4) {
        imageSize = 0;
      }
      // restore alpha channel
      alpha = 255;
    }
  }
 
   void titleText(){
     textFont(titleFont);
     textAlign(CENTER);
     fill(c);
     rectMode(CORNER);
     text(title.toUpperCase().trim(), (width/2)-transX, titleY); // Title Text
     textFont(nameFont);
     fill(darkGray);
     text((name.toLowerCase().trim()), (width/2)-transX, titleY+35); // Name Text
     
     if (ifClicked == true){ // if channel is selected
       //animate text in
       float titleDistY = titleY2 - titleY;
       if (titleY > titleY2) {
         titleY = titleY + titleDistY/8;
       }
       if (titleDistY < 5){
         titleDistY = 0;
       }
     }
     if (ifClicked == false){ // if channel isn't selected
       float titleDistY = titleY2 - titleY-5;
       if (titleY < height-transY+100) {
         titleY = titleY - titleDistY/2;
       }
     }
     
   }
 
  void mostWatched(){
    float triStartX = mostWatchedX+25;
    float triStartY = mostWatchedY+40;

    // rewind button
    fill(c);
    rectMode(CORNER);
    rect(mostWatchedX, mostWatchedY, 140, 80, 10);
    fill(#ffffff);
    triangle(triStartX, triStartY, triStartX+40, triStartY-20, triStartX+40, triStartY+20);
    triangle(triStartX+45, triStartY, triStartX+40+45, triStartY-20, triStartX+40+45, triStartY+20);
    // text
    fill(c);
    textAlign(LEFT);
    textFont(av18Font);
    text("most watched video of 2013", (mostWatchedX), (mostWatchedY+100));
    fill(darkGray);
    textFont(av12BoldFont);
    text(mostWatchedViews + " views", (mostWatchedX), (mostWatchedY+100+15));
    textLeading(12);
    textFont(av12Font);
    text(mostWatchedName, (mostWatchedX), (mostWatchedY+100+20), 300, 100);
    
    if (ifClicked == true) { // if channel is selected
      float watchedDistX = mostWatchedX-mostWatchedX2;
      // animate mostWatched in from left
      if (mostWatchedX < mostWatchedX2) { // final position
        mostWatchedX = mostWatchedX - watchedDistX/8;
      }
      if (watchedDistX < 5) {
        watchedDistX = 0;
      }
    }
    if (ifClicked == false) { // if channel isn't selected
      float watchedDistX = mostWatchedX-(-transX-500);
      if(mostWatchedX > -transX-500) {
        mostWatchedX = mostWatchedX - watchedDistX/8;
      }
    }
    
  }
  
  void disable(){
    // hide channel details to show next  
    ifClicked = false;
  }
  

}
